<template>
  <div >
    <!--引用表格-->
   <BasicTable @register="registerTable" :rowSelection="rowSelection">
     <!--插槽:table标题-->
      <template #tableTitle>
          <a-button type="primary" @click="handleAdd" preIcon="ant-design:plus-outlined"> 新建</a-button>
          <a-button type="primary" @click="handleBatchEditAct" preIcon="ant-design:plus-outlined">批量修改控制活动</a-button>
          <a-button v-show="showBtn" type="primary" preIcon="ant-design:export-outlined" @click="onExportXls"> 导出</a-button>
          <j-upload-button  v-show="showBtn" type="primary" preIcon="ant-design:import-outlined" @click="onImportXls">导入</j-upload-button>
          <a-button   type="primary"  @click="onImportFromFile">导入数据</a-button>
          <a-dropdown v-if="selectedRowKeys.length > 0 && showBtn">
              <template #overlay>
                <a-menu>
                  <a-menu-item key="1" @click="batchHandleDelete">
                    <Icon icon="ant-design:delete-outlined"></Icon>
                    删除
                  </a-menu-item>
                </a-menu>
              </template>
              <a-button>批量操作
                <Icon icon="mdi:chevron-down"></Icon>
              </a-button>
        </a-dropdown>
        <a-button @click="joinCheckHandler">加入检查</a-button>
      </template>
      <template #bodyCell="{ column, record }">
        <template v-if="column.key === 'caName'">
          <JEllipsisFormat :isLink="true"  :value="record.caName" :length="60" @click="goToCa(record)"/>
        </template>
        <template v-if="column.key === 'complianeAsk'">
          <JEllipsisFormat :value="record.complianeAsk" :length="40" />
        </template>
      </template>
       <!--操作栏-->
      <template #action="{ record }">
        <TableAction :actions="getTableAction(record)" :dropDownActions="getDropDownAction(record)"/>
      </template>
      <!--字段回显插槽-->
      <template #htmlSlot="{text}">
         <div v-html="text"></div>
      </template>
      <!--省市区字段回显插槽-->
      <template #pcaSlot="{text}">
         {{ getAreaTextByCode(text) }}
      </template>
      <template #fileSlot="{text}">
         <span v-if="!text" style="font-size: 12px;font-style: italic;">无文件</span>
         <a-button v-else :ghost="true" type="primary" preIcon="ant-design:download-outlined" size="small" @click="downloadFile(text)">下载</a-button>
      </template>
    </BasicTable>
    <!-- 表单区域 -->
    <StComplianeItemModal @register="registerModal" @success="handleSuccess"></StComplianeItemModal>
    <JoinCheckModal @register="registerJCModal" @success="handleSuccess"/>
    <ActSelectModal @register="registerActSelectModal" @setModifyAct="handleSetModifyAct"></ActSelectModal>
  </div>
</template>

<script lang="ts" name="compliane.item-stComplianeItem" setup>
  import { message } from 'ant-design-vue';
import { ref } from 'vue';
import { useRouter } from 'vue-router';
import { batchDelete, deleteOne, getExportUrl, getImportUrl, list,saveItemCa,importFromFile } from './StComplianeItem.api';
import { columns } from './StComplianeItem.data';
import StComplianeItemModal from './components/StComplianeItemModal.vue';
import { useModal } from '/@/components/Modal';
import { BasicTable, TableAction } from '/@/components/Table';
import { useListPage } from '/@/hooks/system/useListPage';
import { downloadFile } from '/@/utils/common/renderUtils';
import JEllipsisFormat from '/@/views/standardlib/components/JEllipsisFormat.vue';
import JoinCheckModal from '/@/views/standardlib/components/JoinCheckModal.vue';
import { useMessage } from '/@/hooks/web/useMessage';

import ActSelectModal from '/@/views/standardlib/components/ActSelectModal.vue';



 const router = useRouter()
  const showBtn = ref(false)
  const checkedKeys = ref<Array<string | number>>([]);
  const emit = defineEmits(['success']);
  //注册model
  const [registerModal, {openModal}] = useModal();
  const [registerJCModal, {openModal:openModalJC}] = useModal();
  const [registerActSelectModal, {openModal:openActSelectModal}] = useModal();
  const props = defineProps({
    complianeInfoRecord: {}
  });
  const { createMessage, createWarningModal } = useMessage();
  //注册table数据
  const { prefixCls,tableContext,onExportXls,onImportXls } = useListPage({
      tableProps:{
           title: '合规条目',
           api: list,
           columns,
           canResize:true,
           showTableSetting: true,
           useSearchForm: false,
           immediate: true,
          //  formConfig: {
          //     //labelWidth: 120,
          //     schemas: searchFormSchema,
          //     autoSubmitOnEnter:true,
          //     showAdvancedButton:true,
          //     fieldMapToNumber: [
          //     ],
          //     fieldMapToTime: [
          //     ],
          //   },
           actionColumn: {
               width: 200,
               fixed:'right'
            },
            beforeFetch(params) {
              params = Object.assign(params,{ column: 'updatedTime', order: 'desc' })
            },
      },
       exportConfig: {
            name:"合规条目",
            url: getExportUrl,
          },
          importConfig: {
            url: getImportUrl,
            success: handleSuccess
          },
  })

  const [registerTable, {reload,setProps},{ rowSelection, selectedRowKeys }] = tableContext
  // watch(
  //   ()=>props.complianeInfoRecord,
  //   (newVal,oldVla)=>{
  //   console.log("-----")
  //   console.log(newVal)
  //   setProps({searchInfo:{complianeNo:newVal.complianeNo}});
  //   reload()
  //   console.log(oldVla)
  //   console.log("-----")
  // })
  function goToCa(record){
    if(record.caName=="-"){
      return
    }
    router.push({path: '/standardlib/controlactivity/StCaMainList',query:{bizNo: record.caNo}})
  }

  function joinCheckHandler(){
      let caNos = selectedRowKeys.value
      if(!caNos||caNos.length==0){
        message.warning('请选择条目！');
        return;
      }
      openModalJC(true, {
          record: {caNos:caNos,type:'complianeItem'},
          isUpdate: false,
          showFooter: true,
        });
    }
   /**
    * 新增事件
    */
  function handleAdd() {
     openModal(true, {
       complianeNo: props.complianeInfoRecord.complianeNo,
       isUpdate: false,
       showFooter: true,
     });
  }

  function handleBatchEditAct() {
    if(selectedRowKeys.value.length==0) {
      createMessage.warning('请选择记录!');
      return false
    }
    openActSelectModal(true, {
       ids:selectedRowKeys.value,
       isUpdate: true,
       showFooter: true,
     });
  }

  function handleEditAct(record) {
    openActSelectModal(true, {
       ids:[record.id],
       isUpdate: true,
       showFooter: true,
     });
  }

  
  function onImportFromFile() {
     let record = props.complianeInfoRecord
     importFromFile({
      complianeNo: record.complianeNo
     })
  
  }


  
   /**
    * 编辑事件
    */
  function handleEdit(record: Recordable) {
     openModal(true, {
       record,
       isUpdate: true,
       showFooter: true,
     });
   }
   /**
    * 详情
   */
  function handleDetail(record: Recordable) {
     openModal(true, {
       record,
       isUpdate: true,
       showFooter: false,
     });
   }
   /**
    * 删除事件
    */
  async function handleDelete(record) {
     await deleteOne({id: record.id}, handleSuccess);
   }
   /**
    * 批量删除事件
    */
  async function batchHandleDelete() {
     await batchDelete({ids: selectedRowKeys.value}, handleSuccess);
   }
   /**
    * 成功回调
    */
  function handleSuccess() {
      (selectedRowKeys.value = []) && reload();
      emit('success')
   }
async function handleSetModifyAct(acts,ids) {
      try {
        for(let i=0;i<ids.length;i++)  {
            await saveItemCa({
              itemid:ids[i],
              caNo:acts.join(",")
            })
          
        }
      } finally {
          handleSuccess()
      }
   }
   /**
      * 操作栏
      */
  function getTableAction(record){
       return [
       {
           label: '删除',
           color: 'error',
           popConfirm: {
             title: '你确定要删除选中的条目吗？',
             confirm: handleDelete.bind(null, record),
           }
         },
         {
           label: '修改',
           onClick: handleEdit.bind(null, record),
         },
 {
           label: '修改活动类型',
           onClick: handleEditAct.bind(null, record),
         },
         {
           label: '详情',
           onClick: handleDetail.bind(null, record),
         }, 
       ]
   }
     /**
        * 下拉操作栏
        */
  function getDropDownAction(record){
       return [
       ]
   }

   defineExpose({setProps,reload})
</script>

<style scoped>

.stCompliceItem textarea {
    height: 40px !important;
}

</style>